--[[

]]
local folder, core = ...


local L = core.L or LibStub("AceLocale-3.0"):GetLocale(folder, true)

--[[
	event,					Zone name,			dL,	mapName,		iA,		iT,		coords
	
	Enable,					The Violet Hold,	1,	VioletHold1,	1,		party,	0,		0		At login in VH
	ZONE_CHANGED_NEW_AREA,	Dalaran,			1,	Dalaran1,		nil,	none,	0.x,	0.x		Entering dalaran from VH
	ZONE_CHANGED_NEW_AREA,	The Violet Hold,	1,	VioletHold1,	1,		party,	0,		0		VH party has no coords.
	Enable,					Orgimmar,			0,	Orgimmar,		nil,	none,	0.x,	0.x		Login in org
	ZONE_CHANGED_NEW_AREA,	Ragefire Chasm,		0,	Kalimdor,		1,		party,	0,		0		Entering RC from org.
	Enable,					Ragefire Chasm,		0,	Kalimdor,		1,		party,	0,		0		Login in RC
]]

--[[
------------------------------------------------------
local disabledSelf = false							--
local enabledZone = {}								--
local disabledZone = {}								--
local function CheckIfFunctional(event)				--
--Check if we're in a zone that we can function in.	--
-- If not, disable addon.							--
------------------------------------------------------
--~ 	local mX, mY = GetPlayerMapPosition("player") --Note, some zones don't return coords on event. eg SotA and VH.
	local iActive, iType = IsInInstance()
--~ 	Debug("CheckIfFunctional", event, "zone:"..tostring(GetZoneText()), "#:"..tostring(GetCurrentMapDungeonLevel()), "map:"..tostring(currentMap), "active:"..tostring(iActive), "type:"..tostring(iType), mX, mY)

--~ 	if zoneData[currentMap] and ((mX ~= 0 or mY ~= 0) or GetCurrentMapDungeonLevel() > 0) then -- 
	if zoneData[currentMap] and 
	(GetCurrentMapDungeonLevel() > 0 or -- WotLK maps have dungeon levels
	iActive == nil or	--We're outside.
	iType == "pvp") then --We're in a battleground.
		if zoneData[currentMap] then
			zoneSize_X, zoneSize_Y = unpack(zoneData[currentMap])
		end
--~ 		if disabledSelf == true and not core:IsEnabled() then
--~ 			if not enabledZone[currentMap] then
--~ 				enabledZone[currentMap] = true --Only show enable message once per login.
--~ 		
--~ 				echo(L["TotemRadius |cff00ff00can|r function in |cffffffff%s|r, enabling self."]:format(GetZoneText()), "["..currentMap.."]")
--~ 			end
--~ 			core:Enable()
--~ 			disabledSelf = false
--~ 		end
--~ 	elseif core:IsEnabled() then
--~ 		if not disabledZone[currentMap] then --Only show disable message once per login.
--~ 			disabledZone[currentMap] = true
--~ 			
--~ 			echo(L["TotemRadius |cffff0000cannot|r function in |cffffffff%s|r, disabling self."]:format(GetZoneText()), "["..currentMap.."]")
--~ 		end

--~ 		core:Disable()
--~ 		disabledSelf = true
	end
end]]



-----------------------------------------------


local LibMapData = LibStub("LibMapData-1.0"); 

if not LibMapData then
	error(folder.." needs LibMapData loaded.")
	return
end

core.LibMapData = LibMapData

do
	local GetMapInfo = GetMapInfo
	local GetCurrentMapDungeonLevel = GetCurrentMapDungeonLevel
	
	local OnEnable = core.OnEnable
	function core:OnEnable(...)
		if OnEnable then OnEnable(self, ...) end
--~ 		
--~ 	--~ 		Debug("minimap", "OnEnable", "RegisterCallback", "MapChanged")
		LibMapData.RegisterCallback(self, "ZoneChanged")
		self.zX, self.zY = LibMapData:MapArea(GetMapInfo(),GetCurrentMapDungeonLevel())
	end
--~ 	
	local OnDisable = core.OnDisable
	function core:OnDisable(...)
		if OnDisable then OnDisable(self, ...) end
		LibMapData.UnregisterAllCallbacks(self) 
	end

end


do
	local GetMapInfo = GetMapInfo
	----------------------------------------------------------
	function core:GetZoneMap()								--
	-- Returns the map the user's currently looking at. 	--
	-- This is used when GetUnitPosition() changes the map.	--
	----------------------------------------------------------
		return LibMapData:MapLocalize(GetMapInfo())
	end
end


do 
	local GetMapInfo = GetMapInfo
	local GetCurrentMapDungeonLevel = GetCurrentMapDungeonLevel
	function core:GetZoneSize()
		return LibMapData:MapArea(GetMapInfo(),GetCurrentMapDungeonLevel())
	end
end

do
	local GetMapInfo = GetMapInfo
	function core:GetCurrentMap()
		return LibMapData:MapLocalize(GetMapInfo())
	end
end

local zoneList = {}
local mapFile
for continent in pairs({ GetMapContinents() }) do
	zoneList[continent] = zoneList[continent] or {}
	for zone, name in pairs({ GetMapZones(continent) }) do
		SetMapZoom(continent, zone)
		mapFile = GetMapInfo()
--~ 		Debug("zD", continent, zone, name, mapFile)
		zoneList[continent][zone] = zoneList[continent][zone] or {name=name, map=mapFile}
	end
end

----------------------------------------------
function core:ZoneIDToMap(cont, zone)		--
-- Get a mapFile from a cont and zone ID.	--
-- This only works for outdoor areas.		--
----------------------------------------------
	return zoneList[cont] and zoneList[cont][zone] and zoneList[cont][zone].map
end